DUMP(8)

NAME
dump - filesystem backup

SYNOPSIS
dump [-0123456789acnuWw] [-B records] [-b blocksize] [-d density] [-f file] [-h level] [-s feet] [-T date] files-to-dump

DESCRIPTION
dump examines files on a filesystem and determines which files need to be backed up. These files are copied to the given disk, tape or other storage medium for safe keeping. A dump that is larger than the output medium is broken into multiple volumes. On most media the size is determined by writing until an end-of-media indication is returned. This can be enforced by using the -a option.

dump works across networks, replacing the functionality of the old rdump program (though dump may still be invoked as rdump). See the -f option for more on writing backups to remote hosts.

Files can be marked with the “nodump” flag using chflags(1), settable only by the file's owner or the superuser. Files with this flag set will only be dumped during full backups. When set on a directory, “nodump” effectively deselects the whole subtree from being dumped, though it will still be scanned. See also the -h option, below.

On media that cannot reliably return an end-of-media indication (such as some cartridge tape drives), each volume is of a fixed size; the actual size is determined by the tape size, density and/or block count options below. By default, the same output file name is used for each volume after prompting the operator to change media.

Rewinding or ejecting tape features after a close operation on a tape device depend on the name of the tape unit device used. See the -f option and st(4) for more information.

The options are as follows:

-0-9
    Dump levels. A level 0, full backup, guarantees the entire file system is copied (but see also the -h option below). A level number above 0, incremental backup, tells dump to copy all files new or modified since the last dump of a lower level. The default level is 0.

-a  “auto-size”. Bypass all tape length considerations, and enforce writing until an end-of-media indication is returned. This option is recommended for most modern tape drives. Use of this option is particularly recommended when appending to an existing tape, or using a tape drive with hardware compression (where you can never be sure about the compression ratio).

-B records
    The number of kilobytes per volume, rounded down to a multiple of the blocksize. This option overrides the calculation of tape size based on length and density.

-b blocksize
    The number of kilobytes per dump record. Since the I/O system slices all requests into chunks of MAXBSIZE (typically 64KB), it is not possible to use a larger blocksize without having problems later with restore(8). Therefore dump will constrain writes to MAXBSIZE.

-c  Change the defaults for use with a cartridge tape drive, with a density of 8000 bpi, and a length of 1700 feet.

-d density
    Set tape density to density. The default is 1600BPI.

-f file
    Write the backup to file; file may be a special device file like /dev/rst0 (a tape drive), /dev/rsd1c (a disk drive), an ordinary file, or ‘-’ (the standard output). See also the TAPE environment variable, below.

    Multiple file names may be given as a single argument separated by commas. Each file will be used for one dump volume in the order listed; if the dump requires more volumes than the number of names given, the last file name will be used for all remaining volumes after prompting for media changes. If the name of the file is of the form “host:file” or “user@host:file”, dump writes to the named file on the remote host using rmt(8).

-h level
    Honor the user “nodump” flag (see above), only for dumps at or above the given level. The default honor level is 1, so that incremental backups omit such files but full backups retain them.

-n  Whenever dump requires operator attention, notify all operators in the group “operator” by means similar to a wall(1).

-s feet
    Attempt to calculate the amount of tape needed at a particular density. If this amount is exceeded, dump prompts for a new tape. It is recommended to be a bit conservative on this option. The default tape length is 2300 feet.

-T date
    Use the specified date as the starting time for the dump instead of the time determined from looking in /etc/dumpdates. The format of date is the same as that of ctime(3). This option is useful for automated dump scripts that wish to dump over a specific period of time. The -T flag is mutually exclusive from the -u flag.

-u  Update the file /etc/dumpdates after a successful dump. The format of /etc/dumpdates is human readable, consisting of one free format record per line: filesystem name, increment level and ctime(3) format dump date. There may be only one entry per filesystem at each level. The file /etc/dumpdates may be edited to change any of the fields, if necessary. If a list of files or subdirectories is being dumped (as opposed to an entire filesystem), then -u is ignored.

-W  dump tells the operator what file systems need to be dumped. This information is gleaned from the files /etc/dumpdates and /etc/fstab. The -W flag causes dump to print out, for each file system in /etc/dumpdates, the most recent dump date and level, and highlights those file systems that should be dumped. If the -W flag is set, all other options are ignored, and dump exits immediately.

-w  Same as -W, but prints only those filesystems which need to be dumped.

files-to-dump is either a mountpoint of a filesystem or a list of files and directories on a single filesystem to be backed up as a subset of the filesystem. In the former case, either the path to a mounted filesystem or the device of an unmounted filesystem can be used. In the latter case, certain restrictions are placed on the backup: -u is ignored, the only dump level that is supported is -0, and all of the files must reside on the same filesystem.

dump requires operator intervention on these conditions: end of tape, end of dump, tape write error, tape open error or disk read error (if there is more than a threshold of 32). In addition to alerting all operators implied by the -n flag, dump interacts with the operator on dump's control terminal at times when dump can no longer proceed, or if something is grossly wrong. All questions dump poses must be answered by typing “yes” or “no”, appropriately.

Since making a dump involves a lot of time and effort for full dumps, dump checkpoints itself at the start of each tape volume. If writing that volume fails for some reason, dump will, with operator permission, restart itself from the checkpoint after the old tape has been rewound and removed, and a new tape has been mounted.

dump tells the operator what is going on at periodic intervals, including usually low estimates of the number of blocks to write, the number of tapes it will take, the time to completion, and the time to the tape change. The output is verbose, so that others know that the terminal controlling dump is busy, and will be for some time.

If dump receives a SIGINFO signal (see the “status” argument of stty(1)) whilst a backup is in progress, statistics on the amount completed, current transfer rate, and estimated finished time, will be written to the standard error output.

In the event of a catastrophic disk event, the time required to restore all the necessary backup tapes or files to disk is dependent on the levels of the dumps taken. A few methods of staggering incremental dumps to either minimize backup effort or restore effort follow:

•   Always start with a level 0 backup, for example:

        # /sbin/dump -0u -f /dev/nrst1 /usr/src

    This should be done at set intervals, say once a month or once every two months, and on a set of fresh tapes that is saved forever.

•   After the level 0 dump, backups of active file systems are taken on each day in a cycle of a week. Once a week, a level 1 dump is taken. The other days of the week a higher level dump is done.

    The following cycle needs at most three tapes to restore to a given point in time, but the dumps at the end of the weekly cycle will require more time and space:

        1 2 2 2 2 2 2

    This sequence requires at most eight tapes to restore, but the size of the individual dumps will be smaller:

        1 2 3 4 5 6 7

    This sequence seeks a compromise between backup and restore effort:

        1 2 2 3 3 4 4

    The weekly level 1 dumps should be done on a set of tapes that is used cyclically. For the daily dumps a tape per day of the week can be used.

•   After several months or so, the daily and weekly tapes should get rotated out of the dump cycle and fresh tapes brought in.

ENVIRONMENT

TAPE
    The default file to use instead of /dev/rst0. See also -f, above.

FILES
/dev/rst0
    default tape unit to dump to
/dev/rst*
    raw SCSI tape interface
/etc/dumpdates
    dump date records
/etc/fstab
    dump table: file systems and frequency
/etc/group
    to find group operator

DIAGNOSTICS
Many, and verbose.

dump exits with zero status on success. Startup errors are indicated with an exit code of 1; abnormal termination is indicated with an exit code of 3.

SEE ALSO
chflags(1), stty(1), fts(3), rcmd(3), st(4), fstab(5), restore(8), rmt(8)

HISTORY
A dump command appeared in AT&T UNIX.

The 4.3BSD option syntax is implemented for backward compatibility but is not documented here.

BUGS
Fewer than 32 read errors on the filesystem are ignored.

Each reel requires a new process, so parent processes for reels already written just hang around until the entire tape is written.

dump with the -W or -w flag does not report filesystems that have never been recorded in /etc/dumpdates, even if listed in /etc/fstab.

When dumping a list of files or subdirectories, access privileges are required to scan the directory (as this is done via the fts(3) routines rather than directly accessing the filesystem).

It would be nice if dump knew about the dump sequence, kept track of the tapes scribbled on, told the operator which tape to mount when, and provided more assistance for the operator running restore(8).